/*
 @C:\Web_635\Sql\End_Conv\Oracle\3987_CDPFUNO_IDENTIFICA_PRODUTOAGUA.SQL

 Descrio:
 Funo para retornar o se o insumo deve ser tratado como AGUA

 Parmetros

 P_CDFILIAL     - Cdigo da filial
 P_CDPRODUTO    - Cdigo do Produto

 raise_application_error(-20501, '' , True);
*/

create or replace FUNCTION IDENTIFICA_PRODUTOAGUA(
   P_CDFILIAL     IN PARAMAN.CDFILIAL%TYPE,
   P_CDPRODUTO    IN PARAMAN.CDPRODAGUA%TYPE) RETURN VARCHAR IS

   V_IDPRODAGUA VARCHAR2(01);
   V_IDMULTPRODUTOS PARAMAN.IDMULTPRODUTOS%TYPE;
   V_AGUA INTEGER;
BEGIN
   V_IDPRODAGUA := 'N';
   BEGIN
      SELECT NVL(IDMULTPRODUTOS, 'N')
        INTO V_IDMULTPRODUTOS
        FROM PARAMAN
       WHERE CDFILIAL = P_CDFILIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDMULTPRODUTOS := 'N';
   END;
   V_AGUA := 0;
   IF V_IDMULTPRODUTOS = 'N' THEN
      SELECT COUNT(1)
        INTO V_AGUA
        FROM PARAMAN
       WHERE CDFILIAL = P_CDFILIAL
         AND CDPRODAGUA = P_CDPRODUTO;
   ELSE
      SELECT COUNT(1)
        INTO V_AGUA
        FROM MULTPRODUTOS
       WHERE CDFILIAL = P_CDFILIAL
         AND CDPRODUTO = P_CDPRODUTO;
   END IF;
   IF V_AGUA > 0 THEN
      V_IDPRODAGUA := 'S';
   END IF;
   RETURN(V_IDPRODAGUA);
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('IDENTIFICA_PRODUTOAGUA','6.49.093'); END;
/


