/* Tabela CONFPADTCARD: Configurao por tipo de cardpio (Alimentao Escolar) */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CONFPADTCARD */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela de configurao do tipo de cardpio CONFPADTCARD,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_PME_CONFPADTCARD
AFTER DELETE
ON CONFPADTCARD FOR EACH ROW
DECLARE
  V_USUARIO   VARCHAR2(40);
  V_TIPO      VARCHAR2(1);
  V_ITPESQ    VARCHAR2(40);
  V_DESC      VARCHAR2(500);
  V_DTOPER    DATE;
  
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
			  
   IF DELETING THEN
      V_DESC := V_DESC || 'Central=' || :OLD.CDFILCENTPME;
      V_DESC := V_DESC || ' TpCard=' || :OLD.CDTIPOCARD;
      V_DESC := V_DESC || ' Servico=' || :OLD.CDSERVFILI;
      V_DESC := V_DESC || ' Sequencial=' || :OLD.NRSEQCNFTCAR;
      V_DESC := V_DESC || ' TpPrato=' || :OLD.CDTIPOPRAT;
      V_DESC := V_DESC || ' Ordem=' || :OLD.NRORDCNFTCAR;
      V_DESC := V_DESC || ' DtAlteracao=' || TO_CHAR(SYSDATE,'DD/MM/YYYY HH24:mi:ss');
	  
      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
	  
      V_TIPO := '3';
      V_ITPESQ := :OLD.CDFILCENTPME||:OLD.CDTIPOCARD||:OLD.CDSERVFILI;
   END IF;
   
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('CONFPADTCARD', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, :OLD.CDFILCENTPME);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_PME_CONFPADTCARD','x.xx.xxx'); END;
/
