CREATE TABLE USR_GPS_ENTRADAS (
  CNPJFILIAL      VARCHAR2(20),
  CR              VARCHAR2(4),
  CHAVE           VARCHAR2(50) NOT NULL,
  DTINC      	  DATE,
  DTENTRADA 	  DATE,
  FINALIDADE      VARCHAR2(10),
  CDFILIAL  	  VARCHAR2(4) NOT NULL,
  NRLANCTONF      VARCHAR2(10) NOT NULL,
  CDFORNECED      VARCHAR2(21),
  NRORG           NUMBER,
  DTINCLUSAO      DATE,
  DTINTERFACEORI  DATE,
  DTINTERFACEDEST DATE,
  CONSTRAINT USR_GPS_ENTRADAS_PK PRIMARY KEY (CHAVE)
)
/

CREATE TABLE USR_GPS_ITENS_ENTRADAS (
  CHAVE      	  VARCHAR2(50) NOT NULL,
  ITEM            VARCHAR2(4)  NOT NULL,
  PRODTEK         VARCHAR2(20) NOT NULL,
  PRODFORNE 	  VARCHAR2(44),
  NRSEQITPROD     VARCHAR2(4),
  CONSTRAINT      USR_GPS_ITENS_ENTRADAS_PK PRIMARY KEY (CHAVE, ITEM),
  CONSTRAINT      USR_GPS_ITENS_ENTRADAS_FK FOREIGN KEY (CHAVE) REFERENCES USR_GPS_ENTRADAS (CHAVE)
)
/

CREATE INDEX USR_GPS_ENTRADAS_DTINC_IDX ON USR_GPS_ENTRADAS (DTINC ASC)
/

ALTER TABLE USR_ITEM_DEVO_MERC ADD NRSEQITPROD VARCHAR2(4)
/

CREATE SEQUENCE USR_NRSEQDEVO START WITH 1;
/

CREATE TABLE USR_DEVO_MERC (
   CHAVE           VARCHAR2(50) NOT NULL,
   CNPJFILIAL      VARCHAR2(14),
   CR              VARCHAR2(4),
   CDSERIE         VARCHAR2(5),
   NRNOTAFISC      VARCHAR2(20),
   CNPJFORNE       VARCHAR2(14),
   DTEMISSAO       DATE,
   NRNOTAFISCORIG  VARCHAR2(20),
   CDSERIEORIG     VARCHAR2(5),
   NRLANCESTQ      VARCHAR2(10),
   DTIMPORTACAO    DATE,
   LOG             VARCHAR2(4000),
   IDATIVO         VARCHAR2(1) NOT NULL ,
   DTINCLUSAO      DATE,
   DTULTATU        DATE,
   CDOPERINCLUSAO VARCHAR2(12),
   CONSTRAINT USR_DEVO_MERC_PK PRIMARY KEY (CHAVE)
)
/
CREATE TABLE USR_ITEM_DEVO_MERC (
   CHAVE           VARCHAR2(50) NOT NULL,
   ITEM            VARCHAR2(4)  NOT NULL,
   PRODTEK         VARCHAR2(20) NOT NULL,
   NRSEQITPROD     VARCHAR2(04) NULL,
   VRQUANTIDADE    FLOAT,
   VRUNITARIO      FLOAT,
   DTIMPORTACAO    DATE,
   IDATIVO         VARCHAR2(1)  NOT NULL,
   DTINCLUSAO      DATE,
   DTULTATU        DATE,
   CDOPERINCLUSAO  VARCHAR2(12),
   CONSTRAINT    USR_ITEM_DEVO_MERC_PK PRIMARY KEY (CHAVE, ITEM),
   CONSTRAINT USR_ITEM_DEVO_FK FOREIGN KEY (CHAVE) REFERENCES USR_DEVO_MERC (CHAVE)
)
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZACAO_ESTRUTURA_BD','6.49.092'); END;
/
