CREATE OR REPLACE PROCEDURE USR_GPS_SAVE_ENTRADAS
IS
   CURSOR C_NOTASENTRADA IS
      SELECT
          NRINSJURFILI                             AS CNPJFILIAL,
          CDFILIRECE                               AS CR,
          NRACESSONFE                              AS CHAVE,
          N.DTINCLUSAO                             AS DTINC,
          DTENTRSAID                               AS DTENTRADA,
          CDEXTIPOOPER                             AS FINALIDADE,
          N.CDFILIAL,
          NRLANCTONF,
          CDFORNECED
      FROM
          NOTAFISCAL  N,
          FILIAL      F,
          TIPOOPERAC  T
      WHERE N.CDFILIRECE = F.CDFILIAL
        AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
        AND N.CDTIPOOPER = T.CDTIPOOPER
        AND N.IDENTRSAIDOP = 'E'
        AND NVL(IDORIGDESTOP, 'F') = 'F'
        AND IDSTATUS <> 'D'
        AND IDSISTEMA <> 'PAG'
        AND N.CDTIPOOPER NOT IN ( '02', '04' )
        AND N.NRACESSONFE IS NOT NULL
        AND N.DTINCLUSAO BETWEEN TRUNC(SYSDATE - 3) AND TRUNC(SYSDATE)
        AND NOT EXISTS (SELECT CHAVE
                          FROM USR_GPS_ENTRADAS
                         WHERE CHAVE = N.NRACESSONFE)
      UNION ALL
      SELECT
         NRINSJURFILI                             AS CNPJFILIAL,
         CDFILIRECE                               AS CR,
         NRACESSONFE                              AS CHAVE,
         N.DTINCLUSAO                             AS DTINC,
         DTENTRSAID                               AS DTENTRADA,
         CDEXTIPOOPER                             AS FINALIDADE,
         N.CDFILIAL,
         NRLANCTONF,
         CDFORNECED
      FROM NOTAFISCAL  N,
           FILIAL      F,
           TIPOOPERAC  T
      WHERE N.CDFILIRECE = F.CDFILIAL
        AND N.IDENTRSAIDOP = T.IDENTRSAIDOP
        AND N.CDTIPOOPER = T.CDTIPOOPER
        AND N.IDENTRSAIDOP = 'E'
        AND NVL(IDORIGDESTOP, 'F') = 'F'
        AND IDSTATUS <> 'D'
        AND IDSISTEMA <> 'PAG'
        AND N.CDTIPOOPER NOT IN ( '02', '04' )
        AND N.NRACESSONFE IS NOT NULL
        AND TRUNC(N.DTULTATU) <> TRUNC(N.DTINCLUSAO)
        AND TRUNC(N.DTINCLUSAO) < SYSDATE - 3
        AND N.DTULTATU BETWEEN TRUNC(SYSDATE - 3) AND TRUNC(SYSDATE)
        AND NOT EXISTS (SELECT CHAVE
                          FROM USR_GPS_ENTRADAS
                         WHERE CHAVE = N.NRACESSONFE);

    CURSOR C_ITENSENTRADA (P_CHAVE IN VARCHAR2, P_CDFORNECED IN VARCHAR2) IS
        SELECT P.CDARVPROD AS PRODTEK, I.NRSEQITPROD AS ITEM, IT.NRSEQITPROD, I.CDPRODUTO AS PRODFORNE
          FROM NOTAFISCAL NF, ITEMPRODUTO IT, PRODUTO P, INTG_ITEMPRODUTO I
         WHERE NF.NRACESSONFE = P_CHAVE
           AND CDFORNECED = P_CDFORNECED
           AND NF.CDFILIAL = IT.CDFILIAL
           AND NF.NRLANCTONF = IT.NRLANCTONF
           AND IT.CDPRODUTO = P.CDPRODUTO
           AND I.NRACESSONFE = NF.NRACESSONFE
           AND LPAD(IT.NRSEQITSAID, 5, '0') = LPAD(I.NRSEQITPROD, 5, '0');

BEGIN
    FOR C_NOTAS IN C_NOTASENTRADA LOOP
        INSERT INTO USR_GPS_ENTRADAS
            (CNPJFILIAL,CR,CHAVE,DTINC,DTENTRADA,
             FINALIDADE,CDFILIAL,NRLANCTONF,CDFORNECED, DTINCLUSAO, DTINTERFACEORI)
        VALUES
            (C_NOTAS.CNPJFILIAL, C_NOTAS.CR, C_NOTAS.CHAVE, C_NOTAS.DTINC, C_NOTAS.DTENTRADA,
             C_NOTAS.FINALIDADE, C_NOTAS.CDFILIAL, C_NOTAS.NRLANCTONF, C_NOTAS.CDFORNECED, SYSDATE, SYSDATE);

        --ATUALIZA TABELA ITEMPRODUTO COM SEQUENCIAL DO XML QUE NAO É PREENCHIDO PELO MOBILE
        FOR C_ITENS IN (SELECT IP.QTITEMPROD, IP.VRUNITITEM, IP.NMPRODUTO, IP.SGUNIDADE, LPAD(IP.NRSEQITPROD, 4, '0') AS NRSEQITPROD, VRTOTAITEM, NF.CDFILIAL, NF.NRLANCTONF
                          FROM INTG_ITEMPRODUTO IP, INTG_NOTAFISCAL N, NOTAFISCAL NF
                         WHERE NF.NRACESSONFE = N.NRACESSONFE
                           AND N.NRACESSONFE = IP.NRACESSONFE
                           AND N.CDFILIAL = C_NOTAS.CDFILIAL
                           AND N.NRLANCTONF = C_NOTAS.NRLANCTONF
        )LOOP
            UPDATE ITEMPRODUTO
               SET QTITEMPRODXML = C_ITENS.QTITEMPROD,
                   VRUNITITEMXML = C_ITENS.VRUNITITEM,
                   VRTOTAITEMXML = C_ITENS.VRTOTAITEM,
                   NMPRODUTOXML = C_ITENS.NMPRODUTO,
                   SGUNIDADEXML = C_ITENS.SGUNIDADE,
                   NRSEQITSAID = C_ITENS.NRSEQITPROD
             WHERE CDFILIAL = C_ITENS.CDFILIAL
               AND NRLANCTONF = C_ITENS.NRLANCTONF
               AND NRSEQITPROD = C_ITENS.NRSEQITPROD
               AND NRSEQITSAID IS NULL;
        END LOOP; -- CLOSE UPDATE ITEMPRODUTO LOOP
        
        FOR C_ITENS IN C_ITENSENTRADA(C_NOTAS.CHAVE, C_NOTAS.CDFORNECED) LOOP
            INSERT INTO USR_GPS_ITENS_ENTRADAS
                (ITEM,PRODTEK,PRODFORNE,CHAVE)
            VALUES
                (C_ITENS.ITEM,C_ITENS.PRODTEK,C_ITENS.PRODFORNE,C_NOTAS.CHAVE);
        END LOOP; --CLOSES ITENSENTRADA LOOP
    COMMIT;
    END LOOP; -- CLOSES NOTASENTRADA LOOP
EXCEPTION
   WHEN OTHERS THEN
      DBMS_OUTPUT.PUT_LINE('UNCAUGHT '||SQLERRM(SQLCODE));
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_GPS_SAVE_ENTRADAS','6.49.092'); END;
/
