create or replace PROCEDURE  USR_GPS_IMPORTA_DEVOLUCAO(
   P_MENSAGEMERRO OUT VARCHAR2)
IS 
   --Tabela pai
   V_NRACESSONFE     USR_DEVO_MERC.CHAVE%TYPE;
   V_NRINSJURFILI    USR_DEVO_MERC.CNPJFILIAL%TYPE;
   V_CDFILIAL        USR_DEVO_MERC.CR%TYPE;
   V_CDSERIE	     USR_DEVO_MERC.CDSERIE%TYPE;
   V_NRNOTAFISC	     USR_DEVO_MERC.NRNOTAFISC%TYPE;
   V_NRINSJURFORN    USR_DEVO_MERC.CNPJFORNE%TYPE;
   V_DTEMISSAO       USR_DEVO_MERC.DTEMISSAO%TYPE;
   V_NRNOTAFISCORIG  USR_DEVO_MERC.NRNOTAFISC%TYPE;
   V_CDSERIEORIG     USR_DEVO_MERC.CDSERIEORIG%TYPE;
   V_CDOPERINCLUSAO  USR_DEVO_MERC.CDOPERINCLUSAO%TYPE;

   --PRODUTO
   V_CDARVPROD 	     USR_ITEM_DEVO_MERC.PRODTEK%TYPE;
   V_NRSEQUITEM      ITLANCTOEST.NRSEQUITEM%TYPE;
   V_NRSEQUITEMNF    ITLANCTOEST.NRSEQUITEM%TYPE;
   V_QTITEMPROD	     USR_ITEM_DEVO_MERC.VRQUANTIDADE%TYPE;
   V_VRFATOCONV      PRODUTO.VRFATOCONV%TYPE;
   V_VRUNITITEM      USR_ITEM_DEVO_MERC.VRUNITARIO%TYPE;

   -- OUTROS
   V_NRLANCTONF	     NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_NRLANCTONFOLD   NOTAFISCAL.NRLANCTONF%TYPE;
   V_NRLANCESTQ	     NOVOCODIGO.NRSEQUENCIAL%TYPE;
   V_CDEMPRESA 	     FILIAL.CDEMPRESA%TYPE;
   V_CDINSCESTA	     FILIAL.CDINSCESTA%TYPE;
   V_CDINSCMUNI	     FILIAL.CDINSCMUNI%TYPE;
   V_CDFORNECEDOR    FORNECEDOR.CDFORNECED%TYPE;
   V_VRTOTALITEM     FLOAT(126);
   V_VRTOTALDEV	     FLOAT(126);
   V_CDPRODUTO       PRODUTO.CDPRODUTO%TYPE;
   V_CDPRODESTO      PRODUTO.CDPRODUTO%TYPE;
   V_NRAUTOFORN	     AUTOFORNE.NRAUTOFORN%TYPE;
   V_NRLANCTONFIT    NOTAFISCAL.NRLANCTONF%TYPE;
   V_NRSEQDEVOL      VARCHAR2(4);
   V_IDTPIJURNF      NOTAFISCAL.IDTPIJURNF%TYPE;
   V_VRTOTLANCTO     FLOAT(126);
   V_DSPRODEMIS      ITEMPRODUTO.DSPRODEMIS%TYPE;
   V_CDALMOXARIFE    ITEMPRODUTO.CDALMOXARIFE%TYPE;
   V_CDLOCALESTOQ    ITEMPRODUTO.CDLOCALESTOQ%TYPE;
   V_NRLOTEESTQ      ITEMPRODUTO.NRLOTEESTQ%TYPE;
   V_NRSUBLOTE       ITEMPRODUTO.NRSUBLOTE%TYPE;
   V_CDMARCA         ITEMPRODUTO.CDMARCA%TYPE;
   V_DTPROGENTAF     ITEMPRODUTO.DTPROGENTAF%TYPE;
   V_CDFILILOGADA    NOTAFISCAL.CDFILIAL%TYPE;
   ---LOOP ITEMS AF
   V_CDPRODRESET     ITEMPRODUTO.CDPRODUTO%TYPE;
   V_QTREMAINING     FLOAT(126);
   V_QTLANCAMENTO    FLOAT(126);
   V_INSERERELAC     BOOLEAN;
   V_CDMODDOCFISC    NOTAFISCAL.CDMODDOCFISC%TYPE;
   V_NRSEQITPROD     ITEMPRODUTO.NRSEQITPROD%TYPE;
   V_PROPORCAO       FLOAT(126);
   V_PRODUTOSIRREG   VARCHAR2(4000);

   CURSOR C_NOTAS IS
      SELECT CHAVE, CNPJFILIAL, CR, TO_CHAR(TO_NUMBER(CDSERIE)) AS CDSERIE, LPAD(NRNOTAFISC, 10, '0'),
             CNPJFORNE, TRUNC(DTEMISSAO), LPAD(NRNOTAFISCORIG, 10, '0'),
             TO_CHAR(TO_NUMBER(CDSERIEORIG)) AS CDSERIEORIG, CDOPERINCLUSAO
        FROM USR_DEVO_MERC
       WHERE DTIMPORTACAO IS NULL;

   CURSOR C_PRODUTONFOLD(C_CHAVE IN VARCHAR2) IS
      SELECT ITEM, PRODTEK, VRQUANTIDADE, VRUNITARIO, VRFATOCONV
        FROM USR_DEVO_MERC USR JOIN USR_ITEM_DEVO_MERC IT ON IT.CHAVE = USR.CHAVE
	     JOIN PRODUTO P ON PRODTEK = P.CDARVPROD
             JOIN FILIAL F ON USR.CR = F.CDFILIAL
         AND NVL(F.IDFUNCAOFILI, 'N') <> 'O'
       WHERE USR.DTIMPORTACAO IS NULL
         AND USR.CHAVE = C_CHAVE
      UNION ALL 
      SELECT ITEM, PRODTEK, VRQUANTIDADE/VRFATOCONV AS VRQUANTIDADE, VRUNITARIO*VRFATOCONV AS VRUNITARIO, VRFATOCONV
        FROM USR_DEVO_MERC USR JOIN USR_ITEM_DEVO_MERC IT ON IT.CHAVE = USR.CHAVE
        JOIN FILIAL F ON USR.CR = F.CDFILIAL
        JOIN RELACPRODOL R ON R.CDPRODARVOL = IT.PRODTEK 
        JOIN PRODUTO P ON R.CDPRARVORIG = P.CDPRODUTO
        AND NVL(F.IDFUNCAOFILI, 'N') = 'O'
       WHERE USR.DTIMPORTACAO IS NULL
         AND USR.CHAVE = C_CHAVE;

    CURSOR C_PRODUTONF(C_CHAVE IN VARCHAR2) IS
      SELECT ITEM, PRODTEK, VRQUANTIDADE, VRUNITARIO, NRSEQITPROD
        FROM USR_DEVO_MERC USR JOIN USR_ITEM_DEVO_MERC IT ON IT.CHAVE = USR.CHAVE
       WHERE USR.DTIMPORTACAO IS NULL
         AND USR.CHAVE = C_CHAVE;

BEGIN
   OPEN C_NOTAS;
   LOOP
      FETCH C_NOTAS INTO  V_NRACESSONFE,
                          V_NRINSJURFILI,
                          V_CDFILIAL,
                          V_CDSERIE,
                          V_NRNOTAFISC,
                          V_NRINSJURFORN,
                          V_DTEMISSAO,
                          V_NRNOTAFISCORIG,
                          V_CDSERIEORIG,
                          V_CDOPERINCLUSAO;
      EXIT WHEN C_NOTAS%NOTFOUND;
    
      P_MENSAGEMERRO := NULL;
      V_NRSEQUITEM := 1;
      V_INSERERELAC := TRUE;
      DBMS_OUTPUT.PUT_LINE('CABECALHO nf open');
      BEGIN
         SELECT CDEMPRESA, CDINSCESTA, CDINSCMUNI
           INTO V_CDEMPRESA, V_CDINSCESTA, V_CDINSCMUNI
           FROM FILIAL
          WHERE CDFILIAL = V_CDFILIAL;
      EXCEPTION WHEN NO_DATA_FOUND THEN
         P_MENSAGEMERRO := 'Codigo de Filial(Unidade) invalido '||V_CDFILIAL;
         GOTO BREAK_STP;
      END;

      BEGIN
         SELECT CDFORNECED, IDTPIJURFORN
           INTO V_CDFORNECEDOR, V_IDTPIJURNF
           FROM FORNECEDOR
          WHERE NRINSJURFORN = V_NRINSJURFORN;
      EXCEPTION WHEN NO_DATA_FOUND THEN
         P_MENSAGEMERRO := 'Fornecedor invalido '||V_NRINSJURFORN;
         GOTO BREAK_STP;
      END;

      BEGIN
         SELECT SUM(VRQUANTIDADE * VRUNITARIO)
           INTO V_VRTOTLANCTO
           FROM USR_ITEM_DEVO_MERC
          WHERE CHAVE = V_NRACESSONFE
            AND DTIMPORTACAO IS NULL
          GROUP BY CHAVE;
      EXCEPTION WHEN NO_DATA_FOUND THEN
         P_MENSAGEMERRO := 'Sem produtos para importar';
         GOTO BREAK_STP;
      END;

      BEGIN
         SELECT NRLANCTONF
           INTO V_NRLANCTONFOLD
           FROM NOTAFISCAL
          WHERE LPAD(NRNOTAFISC, 10, '0') = LPAD(V_NRNOTAFISC, 10, '0')
            AND CDSERIE = V_CDSERIE
            AND CDFORNECED = V_CDFORNECEDOR;
      EXCEPTION WHEN NO_DATA_FOUND THEN
         V_NRLANCTONFOLD := NULL;
      END;

      IF(V_NRLANCTONFOLD IS NULL) THEN
         SELECT MIN(MT.CDMODDOCFISC)
           INTO V_CDMODDOCFISC
           FROM MODDOCFISCTPOP MT
          WHERE MT.IDENTRSAIDOP = 'S'
            AND MT.CDTIPOOPER   = '32';

         V_NRLANCESTQ := NULL;

         BEGIN
            GERA_NOTAFISCAL_CORPO(V_CDFILIAL,
                                  V_CDFILIAL,
                                  V_CDEMPRESA,
                                  '32',
                                  V_CDSERIE,
                                  V_CDFORNECEDOR,
                                  V_DTEMISSAO,
                                  'DFS',
                                  V_NRLANCTONF,
                                  V_NRLANCESTQ,
                                  'S',
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  NULL,
                                  V_CDMODDOCFISC,
                                  NULL,
                                  'N');

            UPDATE NOTAFISCAL
               SET CDFILIEMIT = V_CDFILIAL,
                   CDSERIE = V_CDSERIE,
                   IDSTATUS = 'A',
                   IDSTATUSNFE = 'A',
                   IDBLOQUEADO = 'S',
                   NRACESSONFE = V_NRACESSONFE,
                   DTEMISSAO = V_DTEMISSAO,
                   VRPRODUTOS = V_VRTOTLANCTO,
                   VRNOTAFISC = V_VRTOTLANCTO,
                   NRNOTAFISC = V_NRNOTAFISC,
                   NRNOTAFISCALELE  = LPAD(TO_NUMBER(V_NRNOTAFISC), 9, '0')
             WHERE CDFILIAL = V_CDFILIAL
               AND NRLANCTONF = V_NRLANCTONF;

            INSERT INTO LANCTOESTOQ
               (CDFILIAL, NRLANCESTQ, IDTPLANCTO, DTLANCESTQ, DSLANCESTQ, IDALTCUSMED,
                NRLANCTONF, CDFILIMOVI, CDOPERADOR)
            VALUES
               (V_CDFILIAL, V_NRLANCESTQ, '4', V_DTEMISSAO, 'INTEGRACAO DEVOLUCAO NF: '||LPAD(V_NRNOTAFISC, 10, '0'), 'S',
                V_NRLANCTONF, V_CDFILIAL, V_CDOPERINCLUSAO); -- CRIAR OPERADOR PARA INTEGRACAO?
         EXCEPTION
            WHEN OTHERS THEN
               P_MENSAGEMERRO := SQLERRM(SQLCODE);
               GOTO BREAK_STP;
         END;
      END IF; -- END EXISTE_CABECALHO

      OPEN C_PRODUTONF(V_NRACESSONFE);
      LOOP
         FETCH C_PRODUTONF INTO V_NRSEQUITEMNF,
                                V_CDARVPROD,
                                V_QTITEMPROD,
                                V_VRUNITITEM,
                                V_NRSEQITPROD;
         EXIT WHEN C_PRODUTONF%NOTFOUND;

         BEGIN
            DBMS_OUTPUT.PUT_LINE('Produtos nf open V_CDSERIEORIG= '||V_CDSERIEORIG);

            SELECT NMPRODUTO, CDPRODUTO, CDPRODESTO INTO V_DSPRODEMIS, V_CDPRODUTO, V_CDPRODESTO FROM PRODUTO WHERE CDARVPROD = V_CDARVPROD;
            V_VRTOTALDEV := ROUND(V_QTITEMPROD * V_VRUNITITEM, 2);

            V_CDPRODRESET := NULL;
            V_QTREMAINING := NULL;

            FOR C_ITEMAF IN (SELECT ROWNUM, AF.NRAUTOFORN, IT.CDALMOXARIFE, IT.CDLOCALESTOQ, IT.NRLOTEESTQ, IT.NRSUBLOTE, IT.CDMARCA, IT.DTPROGENTAF,
                                    LPAD(ROWNUM, 4, '0') NRSEQITPROD, IT.NRLANCTONF, NF.CDFILIAL, IT.CDPRODUTO, IT.DSPRODEMIS, (AF.QTNFEFETAF * AF.VRFATOCONV) as QTAF, 
                                    AF.VRFATOCONV as AFCONV, (IT.QTITEMPROD * IT.VRFATOCONV) as QTNF, IT.QTITEMPROD AS QTNFSCONV, IT.VRFATOCONV as ITNFCONV, IT.VRTOTAITEM
                               FROM NOTAFISCAL NF
                                    JOIN (SELECT IT.*, P.CDPRODESTO, P.VRFATOCONV FROM ITEMPRODUTO IT, PRODUTO P WHERE IT.CDPRODUTO = P.CDPRODUTO) IT
                                      ON NF.CDFILIAL = IT.CDFILIAL
                                    AND NF.NRLANCTONF = IT.NRLANCTONF
                                    LEFT JOIN (SELECT AF.*, P.CDPRODESTO, P.VRFATOCONV FROM NFRELACAF AF, PRODUTO P WHERE P.CDPRODUTO = AF.CDPRODUTO) AF
                                      ON NF.CDFILIAL = AF.CDFILIAL
                                    AND NF.NRLANCTONF = AF.NRLANCTONF
                                    AND IT.CDMARCA = AF.CDMARCA
                                    AND IT.CDPRODESTO = AF.CDPRODESTO
                                  WHERE CDFILIRECE    = V_CDFILIAL
                                    AND NRINSJURNF    = V_NRINSJURFORN
                                    AND CDSERIEENTR   = TO_NUMBER(V_CDSERIEORIG)
                                    AND LPAD(NRNOTAFISC, 10, '0')    = LPAD(V_NRNOTAFISCORIG, 10, '0')
                                    AND DECODE(DECODE(V_NRSEQITPROD, '    ', NULL, V_NRSEQITPROD), NULL, IT.CDPRODUTO, IT.NRSEQITPROD) = DECODE(DECODE(V_NRSEQITPROD, '    ', NULL, V_NRSEQITPROD), NULL, V_CDPRODUTO, V_NRSEQITPROD)
                                    AND IT.NRSEQITPROD = NVL(DECODE('    ', NULL, IT.NRSEQITPROD), IT.NRSEQITPROD)
                                    ORDER BY 1 DESC) LOOP

               V_NRSEQUITEM := LPAD(TO_CHAR(V_NRSEQUITEM), 4, '0');
               DBMS_OUTPUT.PUT_LINE('V_NRSEQUITEM='||V_NRSEQUITEM);

               DBMS_OUTPUT.PUT_LINE('C_ITEMAF.QTNForig= '||C_ITEMAF.QTNF||'C_ITEMAF.QTAF= '||C_ITEMAF.QTAF);

               IF V_CDPRODRESET <> C_ITEMAF.CDPRODUTO THEN
                  DBMS_OUTPUT.PUT_LINE('V_CDPRODRESET <> C_ITEMAF.CDPRODUTO'||V_NRSEQUITEM);
                  V_CDPRODRESET := NULL;
               END IF;

               --CALCULA O PERCENTUAL E QUANTIDADE PROPORCIONAL AO VALOR
               V_PROPORCAO := ((V_VRTOTALDEV*100) / C_ITEMAF.VRTOTAITEM) / 100;
               DBMS_OUTPUT.PUT_LINE('V_PROPORCAO= '||V_PROPORCAO);
               V_QTITEMPROD := ROUND((C_ITEMAF.QTNF * V_PROPORCAO), 5);
               DBMS_OUTPUT.PUT_LINE('V_VRTOTALDEV= '||V_VRTOTALDEV||'V_QTITEMPROD= '||V_QTITEMPROD);
               V_VRUNITITEM := ROUND(V_VRTOTALDEV/ (V_QTITEMPROD / C_ITEMAF.ITNFCONV), 3);


               IF V_CDPRODRESET IS NULL THEN
                  V_QTREMAINING := V_QTITEMPROD;
                  V_CDPRODRESET := C_ITEMAF.CDPRODUTO;
                  DBMS_OUTPUT.PUT_LINE('IS NULL V_QTREMAINING= '||V_QTREMAINING||' V_CDPRODRESET= '||V_CDPRODRESET);
               END IF;

               IF ( C_ITEMAF.QTAF < V_QTREMAINING AND C_ITEMAF.ROWNUM > 1 )  THEN
                  V_QTLANCAMENTO := C_ITEMAF.QTAF / C_ITEMAF.ITNFCONV;
                  V_QTREMAINING := (V_QTREMAINING - C_ITEMAF.QTAF);
                  DBMS_OUTPUT.PUT_LINE('IF V_QTLANCAMENTO= '||V_QTLANCAMENTO||' V_QTREMAINING= '||V_QTREMAINING);
               ELSE
                  V_QTLANCAMENTO := V_QTREMAINING / C_ITEMAF.ITNFCONV;
                  V_QTREMAINING := 0;
                  DBMS_OUTPUT.PUT_LINE('ELSE V_QTLANCAMENTO= '||V_QTLANCAMENTO||' V_QTREMAINING= '||V_QTREMAINING);
               END IF;

               DBMS_OUTPUT.PUT_LINE('BEFORE INSERT C_ITEMAF.QTNF= '||C_ITEMAF.QTNF||' V_QTLANCAMENTO= '||V_QTLANCAMENTO);
               DBMS_OUTPUT.PUT_LINE(V_CDFILIAL||' '||V_NRLANCTONF||' '||V_NRSEQUITEM||' '||V_CDFILIAL||' '||C_ITEMAF.NRLANCTONF||' '||V_QTLANCAMENTO);

               V_VRTOTALITEM := ROUND(V_QTLANCAMENTO * V_VRUNITITEM, 3);

               INSERT INTO ITEMPRODUTO
                  (CDFILIAL, NRLANCTONF, NRSEQITPROD, CDPRODUTO,
                   CDPRODEMIS, DSPRODEMIS, IDATUVRESTOQ, QTITEMPROD,
                   VRUNITITEM, VRDESCITEM, VRTOTAITEM, VRCONTITEM,
                   VRBRUTITEM, IDCONFORITEM, CDFILIMOVI,
                   CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE,
                   CDPRODMOVI, NRAUTOFORN, CDMARCA, DTPROGENTAF)
               VALUES
                  (V_CDFILIAL, V_NRLANCTONF, V_NRSEQUITEM, V_CDPRODUTO,
                   V_CDPRODUTO, V_DSPRODEMIS, 'S', V_QTLANCAMENTO,
                   V_VRUNITITEM, 0, V_VRTOTALITEM, V_VRTOTALITEM,
                   V_VRTOTALITEM, 'S', V_CDFILIAL,
                   C_ITEMAF.CDALMOXARIFE, C_ITEMAF.CDLOCALESTOQ, C_ITEMAF.NRLOTEESTQ, C_ITEMAF.NRSUBLOTE,
                   V_CDPRODESTO, C_ITEMAF.NRAUTOFORN, C_ITEMAF.CDMARCA, C_ITEMAF.DTPROGENTAF);

               INSERT INTO ITLANCTOEST
                  (CDFILIAL, NRLANCESTQ, NRSEQUITEM, IDTIPOMOVI, CDPRODUTO, QTTOTLANCTO, VRUNILANCTO,
                   VRTOTLANCTO, DTLANCMOVI, IDORDEMCLC, CDPRODMOVI, QTLANCTOEST, VRLANCTOBRUT, VRLANCTOEST,
                   CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, IDEVOLESTOQ)
               VALUES
                  (V_CDFILIAL, V_NRLANCESTQ, V_NRSEQUITEM, '4', V_CDPRODUTO, (V_QTLANCAMENTO*C_ITEMAF.ITNFCONV), V_VRUNITITEM,
                   V_VRTOTALITEM, V_DTEMISSAO, '9', V_CDPRODESTO, V_QTLANCAMENTO, V_VRUNITITEM, V_VRUNITITEM,
                   V_CDFILIAL, C_ITEMAF.CDALMOXARIFE, C_ITEMAF.CDLOCALESTOQ, C_ITEMAF.NRLOTEESTQ, C_ITEMAF.NRSUBLOTE, 'S');

               IF(V_INSERERELAC = TRUE) THEN
                  INSERT INTO ITEMNOTAFISC
                     (CDFILIAL, NRLANCTONF, NRSEQUITNOTA, CDFILIALIT, NRLANCTONFIT)
                  VALUES
                     (V_CDFILIAL, V_NRLANCTONF, '001', C_ITEMAF.CDFILIAL, C_ITEMAF.NRLANCTONF);

                  V_INSERERELAC := FALSE;
               END IF;

               -- REMOVER COMMIT DESTA PROCEDURE
               USR_GPS_NF_DEVO_AF(V_CDFILIAL, V_NRLANCTONF, V_CDPRODUTO, V_NRSEQUITEM, V_QTLANCAMENTO, V_VRUNITITEM);
               BAIXAAF(V_CDFILIAL, V_CDFILIAL, C_ITEMAF.NRAUTOFORN); -- nao pode ficar no loop de produto

               V_NRSEQUITEM := TO_NUMBER(V_NRSEQUITEM)+1;
            END LOOP; --END LOOP C_ITEMAF
         EXCEPTION
            WHEN OTHERS THEN
               P_MENSAGEMERRO := SQLERRM(SQLCODE);
               DBMS_OUTPUT.PUT_LINE(P_MENSAGEMERRO);
               GOTO BREAK_STP;
         END;
      END LOOP;
      CLOSE C_PRODUTONF;

      BEGIN
         CUSTO_LIQUIDO(V_CDFILIAL, V_NRLANCESTQ, 0, 0, 'S'); -- nao pode ficar no loop de produto
         ATUALIZA_ESTOQUE(V_CDFILIAL, V_DTEMISSAO, SYSDATE, V_CDFILIAL, V_NRLANCESTQ, NULL); -- nao pode ficar no loop de produto
        
         V_PRODUTOSIRREG := '';
         /* Atualizar a Itlanctoest para não evoluir estoque caso encontre erro ao atualizar o estoque */
         FOR C_PRODIRREG IN (SELECT NRMOVILOTE, CDFILIAL, CDALMOXARIFE, CDLOCALESTOQ,
                                    M.CDPRODUTO, NRLOTEESTQ, NRSUBLOTE, CDARVPROD
                               FROM MOVILOTE M INNER JOIN PRODUTO P ON M.CDPRODUTO = P.CDPRODUTO
                              WHERE NRMOVILOTE = V_CDFILIAL||V_NRLANCESTQ
                                AND CDFILIAL   = V_CDFILIAL) LOOP
            UPDATE ITLANCTOEST
               SET IDEVOLESTOQ  = 'N'
             WHERE CDFILIAL     = V_CDFILIAL
               AND NRLANCESTQ   = V_NRLANCESTQ
               AND CDALMOXARIFE = C_PRODIRREG.CDALMOXARIFE
               AND CDLOCALESTOQ = C_PRODIRREG.CDLOCALESTOQ
               AND CDPRODUTO    = C_PRODIRREG.CDPRODUTO
               AND NRLOTEESTQ   = C_PRODIRREG.NRLOTEESTQ
               AND NRSUBLOTE    = C_PRODIRREG.NRSUBLOTE;
            
            V_PRODUTOSIRREG := V_PRODUTOSIRREG||C_PRODIRREG.CDARVPROD||', ';
         END LOOP;
         
         IF LENGTH(V_PRODUTOSIRREG) > 0 THEN
            P_MENSAGEMERRO := SUBSTR('NF DEVOLUCAOO ' || LPAD(V_NRNOTAFISC, 10, '0') || '. Algum(ns) produto(s) tornariam o estoque irregular. Produtos: '||V_PRODUTOSIRREG, 1, 4000);
         END IF;

        DELETE MOVILOTE
         WHERE NRMOVILOTE = V_CDFILIAL||V_NRLANCESTQ;

      EXCEPTION
         WHEN OTHERS THEN
            P_MENSAGEMERRO := SQLERRM(SQLCODE);
            DBMS_OUTPUT.PUT_LINE(P_MENSAGEMERRO);
      END;
      <<BREAK_STP>>

      IF P_MENSAGEMERRO IS NOT NULL THEN
         DBMS_OUTPUT.PUT_LINE('ROLLBACK '||P_MENSAGEMERRO);
         ROLLBACK;

         P_MENSAGEMERRO := 'N;'||P_MENSAGEMERRO||';'||V_CDFILIAL||V_NRLANCTONF;

         UPDATE USR_DEVO_MERC
            SET DTIMPORTACAO = SYSDATE,
                LOG    = P_MENSAGEMERRO
          WHERE CHAVE = V_NRACESSONFE;

         UPDATE USR_ITEM_DEVO_MERC
            SET DTIMPORTACAO = SYSDATE
          WHERE CHAVE = V_NRACESSONFE;

         COMMIT;
      ELSE
         -- UPDATES THE INTEGRATION TABLE
         P_MENSAGEMERRO := 'S'||';Operacao realizada com sucesso.;'||V_CDFILIAL||V_NRLANCTONF;

         UPDATE USR_DEVO_MERC
            SET DTIMPORTACAO = SYSDATE,
                LOG          = P_MENSAGEMERRO
          WHERE CHAVE = V_NRACESSONFE;

         UPDATE USR_ITEM_DEVO_MERC
            SET DTIMPORTACAO = SYSDATE
          WHERE CHAVE = V_NRACESSONFE;

         DBMS_OUTPUT.PUT_LINE('COMMIT');
         COMMIT;
   END IF;
   END LOOP;
   CLOSE C_NOTAS;
   
   IF P_MENSAGEMERRO IS NULL THEN
    P_MENSAGEMERRO := 'S'||';Operacao realizada com sucesso.;';
   END IF;
   
EXCEPTION
   WHEN OTHERS THEN
      P_MENSAGEMERRO := 'N;UNCAUGHT '||SQLERRM(SQLCODE)||';';
      DBMS_OUTPUT.PUT_LINE('UNCAUGHT '||P_MENSAGEMERRO);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_GPS_IMPORTA_DEVOLUCAO','6.49.092'); END;
/
