create or replace FUNCTION VALOR_PRODUTOAGUA(
   P_CDFILIAL     IN PARAMAN.CDFILIAL%TYPE,
   P_CDPRODUTO    IN PARAMAN.CDPRODAGUA%TYPE) RETURN FLOAT IS

   V_VRPRODAGUA PARAMAN.VRPRODAGUA%TYPE;
   V_IDMULTPRODUTOS PARAMAN.IDMULTPRODUTOS%TYPE;
BEGIN
   V_VRPRODAGUA := 0;
   BEGIN
      SELECT NVL(IDMULTPRODUTOS, 'N')
        INTO V_IDMULTPRODUTOS
        FROM PARAMAN
       WHERE CDFILIAL = P_CDFILIAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDMULTPRODUTOS := 'N';
   END;
   IF V_IDMULTPRODUTOS = 'N' THEN
      BEGIN
         SELECT VRPRODAGUA
           INTO V_VRPRODAGUA
           FROM PARAMAN
          WHERE CDFILIAL = P_CDFILIAL
            AND CDPRODAGUA = P_CDPRODUTO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRPRODAGUA := 0;
      END;
   ELSE
      BEGIN
         SELECT VRPRODAGUA
           INTO V_VRPRODAGUA
           FROM MULTPRODUTOS
          WHERE CDFILIAL = P_CDFILIAL
            AND CDPRODUTO = P_CDPRODUTO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_VRPRODAGUA := 0;
      END;
   END IF;
   RETURN(V_VRPRODAGUA);
END;
/
